      subroutine ActivateRmat(nr,ier)
      integer   nr              ! input
      integer   ier             ! output
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer activermat
      logical DoRmatTrans
      logical TmatIsRealList(maxnrmat)
      real    reducedrmatlist(3,3,maxnrmat)
      real    rmatlist(3,3,maxnrmat)
      real    dmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,TmatIsRealList,
     +     reducedrmatlist,rmatlist,dmatlist,tmatlist,sigmacelllist,
     +     sigmavolumelist
      character rmatbravaislist(maxnrmat)*2
      character bravaislist(maxnrmat)*2
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer QvecTypes(maxnrmat)
      integer nqveclist(maxnrmat)
      real    qvecradiuslist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      logical nqvpautolist(maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      logical qvpactivelist(maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/QvecTypes,nqveclist,qvecradiuslist,
     +     qvvectorlist,qvorderlist,nqvpautolist,nqvplist,qvplist,
     +     qvpactivelist,qvphkllist
      external  rmatxxx
      integer   i
      integer   j
      if(nr.eq.activermat) then
        ier = RmatErrorNone
        return
      endif
      call CheckRmat(nr,ier)
      if(ier.ne.RmatErrorNone) return
      rmattitle = rmattitlelist(nr)
      call GetMat(reducedrmatlist,nr,reducedrmat)
      rmatbravais = rmatbravaislist(nr)
      TmatIsReal = TmatIsRealList(nr)
      call GetMat(tmatlist,nr,tmat)
      call GetMat(rmatlist,nr,rmat)
      call GetMat(dmatlist,nr,dmat)
      if(DoRmatTrans) then
        pg = pglist(nr)
        bravais = bravaislist(nr)
      else
        bravais = rmatbravaislist(nr)
        call dmatpg(dmat,pgAxisZero,pgAngleZero,pg)
      endif
      do i=1,6
        sigmacell(i) = sigmacelllist(i,nr)
      enddo
      sigmavolume = sigmavolumelist(nr)
      QvecType = QvecTypes(nr)
      qvecradius = QvecRadiusList(nr)
      qvecradiusactive = qvecradius
      nqvec = nqveclist(nr)
      do i=1,nqvec
        do j=1,3
          qvvector(j,i) = qvvectorlist(j,i,nr)
        enddo
        qvorder(i) = qvorderlist(i,nr)
      enddo
      nqvp = nqvplist(nr)
      nqvpauto = nqvpautolist(nr)
      do i=1,nqvp
        do j=1,nqvec
          qvp(j,i) = qvplist(j,i,nr)
        enddo
        qvpactive(i) = qvpactivelist(i,nr)
        do j=1,3
          qvphkl(j,i) = qvphkllist(j,i,nr)
        enddo
      enddo
      activermat = nr
      ier = RmatErrorNone
      return
      end                       ! ActivateRmat
      subroutine BuildRmatFromCell(a,al,myrmat,mydmat,message,ier)
      real      a(3)
      real      al(3)
      real      myrmat(3,3)
      real      mydmat(3,3)
      character message*(*)
      integer   ier
      logical   debug
      parameter (debug=.false.)
      character Routine*(*)
      parameter (Routine='BuildRmat')
      real      matrix(3,3)
      integer   inverterror
      matrix(1,1) = a(1)
      matrix(1,2) = 0.0
      matrix(1,3) = 0.0
      matrix(2,1) = a(2)*cos(al(3))
      matrix(2,2) = a(2)*sin(al(3))
      matrix(2,3) = 0.0
      matrix(3,1) = a(3)*cos(al(2))
      matrix(3,2) = (a(2)*a(3)*cos(al(1))-matrix(2,1)*matrix(3,1))
     +     /matrix(2,2)
      matrix(3,3) = a(3)**2 - matrix(3,1)**2 - matrix(3,2)**2
      if(matrix(3,3).lt.0.01) then
        ier = 1
        call str_flush
        call str_out(ROUTINE)
        call str_vector_out(a,'cell')
        call str_gradvector_out(al,' ')
        call str_flush
        call writemat(6,matrix,'matrix')
        message = 'Cannot build matrix'
        goto 900
      else
        matrix(3,3) = sqrt(matrix(3,3))
      endif
      call CopyMat(matrix,mydmat)
      call inVertMat(mydmat,myrmat,inverterror)
      if(inverterror.ne.0) then
        message = 'Cannot invert matrix'
        ier = 1
        goto 900
      endif
      if(debug) then
        call str_flush
        call write2mat(6,myrmat,mydmat,'myRmat','myDmat')
      endif
      message = 'ok'
      ier = 0
  900 continue
      call str_2string(routine,message,'#: #',message)
      return
      end                       ! BuildRmatFromCell
      subroutine CellConstraints(pg,a,al,changed)
      character pg*(*)          ! input
      real      a(3)            ! input/output
      real      al(3)           ! input/output
      logical   changed         ! output
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      character crystal*20
      integer   i
      real      f
      changed = .true.
      call pg2crystal(pg,crystal)
      if(crystal.eq.'monoclinic') then
        al(1) = PiOver2
        al(3) = PiOver2
      else if(crystal.eq.'orthorhombic') then
        do i=1,3
          al(i) = PiOver2
        enddo
      else if(crystal.eq.'tetragonal') then
        f = (a(1)+a(2))/2
        a(1) = f
        a(2) = f
        do i=1,3
          al(i) = PiOver2
        enddo
      else if(crystal.eq.'hexagonal'.or.crystal.eq.'trigonal') then
        f = (a(1)+a(2))/2
        a(1) = f
        a(2) = f
        al(1) = PiOver2
        al(2) = PiOver2
        al(3) = 120.0/grad
      else if(crystal.eq.'rhombohedral') then
        f = (a(1)+a(2)+a(3))/3
        do i=1,3
          a(i) = f
        enddo
        f = (al(1)+al(2)+al(3))/3
        do i=1,3
          al(i) = f
        enddo
      else if(crystal.eq.'cubic') then
        f = (a(1)+a(2)+a(3))/3
        do i=1,3
          a(i) = f
        enddo
        do i=1,3
          al(i) = PiOver2
        enddo
      else
        changed = .false.
      endif
      return
      end                       ! CellConstraints
      subroutine CheckRmat(nr,ier)
      integer   nr              ! input
      integer   ier             ! output
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer activermat
      logical DoRmatTrans
      logical TmatIsRealList(maxnrmat)
      real    reducedrmatlist(3,3,maxnrmat)
      real    rmatlist(3,3,maxnrmat)
      real    dmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,TmatIsRealList,
     +     reducedrmatlist,rmatlist,dmatlist,tmatlist,sigmacelllist,
     +     sigmavolumelist
      character rmatbravaislist(maxnrmat)*2
      character bravaislist(maxnrmat)*2
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer QvecTypes(maxnrmat)
      integer nqveclist(maxnrmat)
      real    qvecradiuslist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      logical nqvpautolist(maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      logical qvpactivelist(maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/QvecTypes,nqveclist,qvecradiuslist,
     +     qvvectorlist,qvorderlist,nqvpautolist,nqvplist,qvplist,
     +     qvpactivelist,qvphkllist
      external  rmatxxx
      if(nr.lt.1.or.nr.gt.maxnrmat) then
        ier = RmatErrorRange
        return
      endif
      if(.not.rmatavailable(nr)) then
        ier = RmatErrorUnavailable
        return
      endif
      ier = RmatErrorNone
      return
      end                       ! CheckRmat
      subroutine CountRmat
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer activermat
      logical DoRmatTrans
      logical TmatIsRealList(maxnrmat)
      real    reducedrmatlist(3,3,maxnrmat)
      real    rmatlist(3,3,maxnrmat)
      real    dmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,TmatIsRealList,
     +     reducedrmatlist,rmatlist,dmatlist,tmatlist,sigmacelllist,
     +     sigmavolumelist
      character rmatbravaislist(maxnrmat)*2
      character bravaislist(maxnrmat)*2
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer QvecTypes(maxnrmat)
      integer nqveclist(maxnrmat)
      real    qvecradiuslist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      logical nqvpautolist(maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      logical qvpactivelist(maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/QvecTypes,nqveclist,qvecradiuslist,
     +     qvvectorlist,qvorderlist,nqvpautolist,nqvplist,qvplist,
     +     qvpactivelist,qvphkllist
      integer i
      external  rmatxxx
      logical   debug
      parameter (debug=.false.)
      nrmatavailable = 0
      highestnqvec = 0
      do i=1,maxnrmat
        if(rmatavailable(i)) then
          nrmatavailable = nrmatavailable + 1
          highestnrmat = i
          highestnqvec = max(highestnqvec,nqveclist(i))
        endif
      enddo
      if(debug) then
        call str_out('CountRmat')
        call str_integer_out(nrmatavailable,'available #')
        call str_integer_out(highestnrmat,'highest')
        call str_integer_out(highestnqvec,'highestnqvec=#')
        call operator
      endif
      return
      end                       ! CountRmat
      subroutine dmatpg(dm,axiszero,anglezero,pg)
      real      dm(3,3)
      real      axiszero
      real      anglezero
      character pg*(*)
      real      a(3)
      real      al(3)
      character string*80
      call celldim(dm,a,al)
      call GetPG(a,al,axiszero,anglezero,pg,string)
      return
      end                       ! Dmatpg
      subroutine GetPG(a,al,axiszero,anglezero,short,long)
      real      a(3)            ! input
      real      al(3)           ! input
      real      axiszero        ! input
      real      anglezero       ! input
      character short*(*)       ! output
      character long*(*)        ! output
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer pgTricl1
      integer pgTricl2
      integer pgMono1
      integer pgMono2
      integer pgMono3
      integer pgMono4
      integer pgMono5
      integer pgMono6
      integer pgMono7
      integer pgMono8
      integer pgMono9
      integer pgOrtho1
      integer pgOrtho2
      integer pgOrtho3
      integer pgOrtho4
      integer pgOrtho5
      integer pgTetraL1
      integer pgTetraL2
      integer pgTetraL3
      integer pgTetraH1
      integer pgTetraH2
      integer pgTetraH3
      integer pgTetraH4
      integer pgTetraH5
      integer pgTrigoL1
      integer pgTrigoL2
      integer pgTrigoH1
      integer pgTrigoH2
      integer pgTrigoH3
      integer pgTrigoH4
      integer pgTrigoH5
      integer pgTrigoH6
      integer pgHexaL1
      integer pgHexaL2
      integer pgHexaL3
      integer pgHexaH1
      integer pgHexaH2
      integer pgHexaH3
      integer pgHexaH4
      integer pgHexaH5
      integer pgRhomboL1
      integer pgRhomboL2
      integer pgRhomboH1
      integer pgRhomboH2
      integer pgRhomboH3
      integer pgCubicL1
      integer pgCubicL2
      integer pgCubicH1
      integer pgCubicH2
      integer pgCubicH3
      parameter (pgTricl1=1)
      parameter (pgTricl2=pgTricl1+1)
      parameter (pgMono1=pgTricl2+1)
      parameter (pgMono2=pgMono1+1)
      parameter (pgMono3=pgMono2+1)
      parameter (pgMono4=pgMono3+1)
      parameter (pgMono5=pgMono4+1)
      parameter (pgMono6=pgMono5+1)
      parameter (pgMono7=pgMono6+1)
      parameter (pgMono8=pgMono7+1)
      parameter (pgMono9=pgMono8+1)
      parameter (pgOrtho1=pgMono9+1)
      parameter (pgOrtho2=pgOrtho1+1)
      parameter (pgOrtho3=pgOrtho2+1)
      parameter (pgOrtho4=pgOrtho3+1)
      parameter (pgOrtho5=pgOrtho4+1)
      parameter (pgTetraL1=pgOrtho5+1)
      parameter (pgTetraL2=pgTetraL1+1)
      parameter (pgTetraL3=pgTetraL2+1)
      parameter (pgTetraH1=pgTetraL3+1)
      parameter (pgTetraH2=pgTetraH1+1)
      parameter (pgTetraH3=pgTetraH2+1)
      parameter (pgTetraH4=pgTetraH3+1)
      parameter (pgTetraH5=pgTetraH4+1)
      parameter (pgTrigoL1=pgTetraH5+1)
      parameter (pgTrigoL2=pgTrigoL1+1)
      parameter (pgTrigoH1=pgTrigoL2+1)
      parameter (pgTrigoH2=pgTrigoH1+1)
      parameter (pgTrigoH3=pgTrigoH2+1)
      parameter (pgTrigoH4=pgTrigoH3+1)
      parameter (pgTrigoH5=pgTrigoH4+1)
      parameter (pgTrigoH6=pgTrigoH5+1)
      parameter (pgHexaL1=pgTrigoH6+1)
      parameter (pgHexaL2=pgHexaL1+1)
      parameter (pgHexaL3=pgHexaL2+1)
      parameter (pgHexaH1=PgHexaL3+1)
      parameter (pgHexaH2=PgHexaH1+1)
      parameter (pgHexaH3=PgHexaH2+1)
      parameter (pgHexaH4=PgHexaH3+1)
      parameter (pgHexaH5=PgHexaH4+1)
      parameter (pgRhomboL1=PgHexaH5+1)
      parameter (pgRhomboL2=PgRhomboL1+1)
      parameter (pgRhomboH1=PgRhomboL2+1)
      parameter (pgRhomboH2=PgRhomboH1+1)
      parameter (pgRhomboH3=PgRhomboH2+1)
      parameter (pgCubicL1=PgRhomboH3+1)
      parameter (pgCubicL2=PgCubicL1+1)
      parameter (pgCubicH1=PgCubicL2+1)
      parameter (pgCubicH2=PgCubicH1+1)
      parameter (pgCubicH3=PgCubicH2+1)
      integer maxpg
      parameter (maxpg=pgCubicH3)
      integer pgTriclFirst
      integer pgTriclLast
      integer pgMonoFirst
      integer pgMonoLast
      integer pgOrthoFirst
      integer pgOrthoLast
      integer pgTetraLfirst
      integer pgTetraLlast
      integer pgTetraHfirst
      integer pgTetraHlast
      integer pgTrigoLfirst
      integer pgTrigoLlast
      integer pgTrigoHfirst
      integer pgTrigoHlast
      integer pgHexaLfirst
      integer pgHexaLlast
      integer pgHexaHfirst
      integer pgHexaHlast
      integer pgRhomboLfirst
      integer pgRhomboLlast
      integer pgRhomboHfirst
      integer pgRhomboHlast
      integer pgCubicLfirst
      integer pgCubicLlast
      integer pgCubicHfirst
      integer pgCubicHlast
      parameter(pgTriclFirst=pgTricl1)
      parameter(pgTriclLast=pgTricl2)
      parameter(pgMonoFirst=pgMono1)
      parameter(pgMonoLast=pgMono9)
      parameter(pgOrthoFirst=pgOrtho1)
      parameter(pgOrthoLast=pgOrtho5)
      parameter(pgTetraLfirst=pgTetraL1)
      parameter(pgTetraLlast=pgTetraL3)
      parameter(pgTetraHfirst=pgTetraH1)
      parameter(pgTetraHlast=pgTetraH5)
      parameter(pgTrigoLfirst=pgTrigoL1)
      parameter(pgTrigoLlast=pgTrigoL2)
      parameter(pgTrigoHfirst=pgTrigoH1)
      parameter(pgTrigoHlast=pgTrigoH6)
      parameter(pgHexaLfirst=pgHexaL1)
      parameter(pgHexaLlast=pgHexaL3)
      parameter(pgHexaHfirst=pgHexaH1)
      parameter(pgHexaHlast=pgHexaH5)
      parameter(pgRhomboLfirst=pgRhomboL1)
      parameter(pgRhomboLlast=pgRhomboL2)
      parameter(pgRhomboHfirst=pgRhomboH1)
      parameter(pgRhomboHlast=pgRhomboH3)
      parameter(pgCubicLfirst=pgCubicL1)
      parameter(pgCubicLlast=pgCubicL2)
      parameter(pgCubicHfirst=pgCubicH1)
      parameter(pgCubicHlast=pgCubicH3)
      integer CurrentSymbol
      logical Centric
      integer nPgQvec
      integer npg
      integer npgAcentric
      integer pgMatrixList(3,3,49)
      integer pgQvecMatrixList(3,3,49)
      integer pgMatrixListAcentric(3,3,49)
      integer pgQvecMatrixListAcentric(3,3,49)
      common /common_symm/ CurrentSymbol,centric,nPgQvec,npg,
     + npgAcentric,pgMatrixList,pgQvecMatrixList,pgMatrixListAcentric,
     + pgQvecMatrixListAcentric
      character pgnames(maxpg)*6
      common /common_symm_char/ pgnames
      logical   rectangle(3)
      integer   i
      do i=1,3
        rectangle(i) = (abs(PiOver2-al(i)).lt.anglezero)
      enddo
      if(rectangle(1).and.rectangle(2).and.
     +     abs(120.0/Grad-al(3)).lt.anglezero.and.
     +     abs(a(1)-a(2)).lt.axiszero) then
        call pgshort(pgTrigoLlast,short)
      else if(rectangle(1).and.rectangle(2).and.rectangle(3)) then
        if(abs(a(1)-a(2)).lt.axiszero) then
          if(abs(a(1)-a(3)).lt.axiszero) then
            call pgshort(pgCubicLlast,short)
          else
            call pgshort(pgTetraLlast,short)
          endif
        else
          call pgshort(pgOrthoLast,short)
        endif
      else if(rectangle(1).and.rectangle(3)) then
        call pgshort(pgMono3,short)
      else if(abs(al(1)-al(2)).lt.anglezero.and.
     +       abs(al(1)-al(3)).lt.anglezero.and.
     +       abs(a(1)-a(2)).lt.axiszero.and.
     +       abs(a(1)-a(3)).lt.axiszero) then
        call pgshort(pgRhomboLlast,short)
      else
        call pgshort(pgTriclLast,short)
      endif
      call PGString(short,long)
      return
      end                       ! GetPG
      subroutine GetRmatFull(rm,dm,b,p,message,ier)
      real      rm(3,3)
      real      dm(3,3)
      character b*(*)
      character p*(*)
      character message*(*)
      integer   ier
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer activermat
      logical DoRmatTrans
      logical TmatIsRealList(maxnrmat)
      real    reducedrmatlist(3,3,maxnrmat)
      real    rmatlist(3,3,maxnrmat)
      real    dmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,TmatIsRealList,
     +     reducedrmatlist,rmatlist,dmatlist,tmatlist,sigmacelllist,
     +     sigmavolumelist
      character rmatbravaislist(maxnrmat)*2
      character bravaislist(maxnrmat)*2
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer QvecTypes(maxnrmat)
      integer nqveclist(maxnrmat)
      real    qvecradiuslist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      logical nqvpautolist(maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      logical qvpactivelist(maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/QvecTypes,nqveclist,qvecradiuslist,
     +     qvvectorlist,qvorderlist,nqvpautolist,nqvplist,qvplist,
     +     qvpactivelist,qvphkllist
      if(activermat.eq.0) then
        message = 'No active rmat available'
        ier = 1
      else
        call copymat(rmat,rm)
        call copymat(dmat,dm)
        b = bravais
        p = pg
        message = 'active rmat copied'
        ier = 0
      endif
      return
      end                       ! GetRmatFull
      subroutine initaxes
      logical   AxesInitDone
      common /common_axes_init/ AxesInitDone
      real      x_axis(3)
      real      y_axis(3)
      real      z_axis(3)
      common /common_axes/ x_axis,y_axis,z_axis
      character xyz(3)*1
      character abc(3)*1
      character albega(3)*5
      common /common_axes_char/ xyz,abc,albega
      data AxesInitDone /.false./
      if(AxesInitDone) return
      AxesInitDone = .true.
      xyz(1) = 'x'
      xyz(2) = 'y'
      xyz(3) = 'z'
      abc(1) = 'a'
      abc(2) = 'b'
      abc(3) = 'c'
      albega(1) = 'alpha'
      albega(2) = 'beta'
      albega(3) = 'gamma'
      call BuildVector(1.0,0.0,0.0,x_axis)
      call BuildVector(0.0,1.0,0.0,y_axis)
      call BuildVector(0.0,0.0,1.0,z_axis)
      return
      end                       ! initaxes
      block data lauexxx
      integer pgTricl1
      integer pgTricl2
      integer pgMono1
      integer pgMono2
      integer pgMono3
      integer pgMono4
      integer pgMono5
      integer pgMono6
      integer pgMono7
      integer pgMono8
      integer pgMono9
      integer pgOrtho1
      integer pgOrtho2
      integer pgOrtho3
      integer pgOrtho4
      integer pgOrtho5
      integer pgTetraL1
      integer pgTetraL2
      integer pgTetraL3
      integer pgTetraH1
      integer pgTetraH2
      integer pgTetraH3
      integer pgTetraH4
      integer pgTetraH5
      integer pgTrigoL1
      integer pgTrigoL2
      integer pgTrigoH1
      integer pgTrigoH2
      integer pgTrigoH3
      integer pgTrigoH4
      integer pgTrigoH5
      integer pgTrigoH6
      integer pgHexaL1
      integer pgHexaL2
      integer pgHexaL3
      integer pgHexaH1
      integer pgHexaH2
      integer pgHexaH3
      integer pgHexaH4
      integer pgHexaH5
      integer pgRhomboL1
      integer pgRhomboL2
      integer pgRhomboH1
      integer pgRhomboH2
      integer pgRhomboH3
      integer pgCubicL1
      integer pgCubicL2
      integer pgCubicH1
      integer pgCubicH2
      integer pgCubicH3
      parameter (pgTricl1=1)
      parameter (pgTricl2=pgTricl1+1)
      parameter (pgMono1=pgTricl2+1)
      parameter (pgMono2=pgMono1+1)
      parameter (pgMono3=pgMono2+1)
      parameter (pgMono4=pgMono3+1)
      parameter (pgMono5=pgMono4+1)
      parameter (pgMono6=pgMono5+1)
      parameter (pgMono7=pgMono6+1)
      parameter (pgMono8=pgMono7+1)
      parameter (pgMono9=pgMono8+1)
      parameter (pgOrtho1=pgMono9+1)
      parameter (pgOrtho2=pgOrtho1+1)
      parameter (pgOrtho3=pgOrtho2+1)
      parameter (pgOrtho4=pgOrtho3+1)
      parameter (pgOrtho5=pgOrtho4+1)
      parameter (pgTetraL1=pgOrtho5+1)
      parameter (pgTetraL2=pgTetraL1+1)
      parameter (pgTetraL3=pgTetraL2+1)
      parameter (pgTetraH1=pgTetraL3+1)
      parameter (pgTetraH2=pgTetraH1+1)
      parameter (pgTetraH3=pgTetraH2+1)
      parameter (pgTetraH4=pgTetraH3+1)
      parameter (pgTetraH5=pgTetraH4+1)
      parameter (pgTrigoL1=pgTetraH5+1)
      parameter (pgTrigoL2=pgTrigoL1+1)
      parameter (pgTrigoH1=pgTrigoL2+1)
      parameter (pgTrigoH2=pgTrigoH1+1)
      parameter (pgTrigoH3=pgTrigoH2+1)
      parameter (pgTrigoH4=pgTrigoH3+1)
      parameter (pgTrigoH5=pgTrigoH4+1)
      parameter (pgTrigoH6=pgTrigoH5+1)
      parameter (pgHexaL1=pgTrigoH6+1)
      parameter (pgHexaL2=pgHexaL1+1)
      parameter (pgHexaL3=pgHexaL2+1)
      parameter (pgHexaH1=PgHexaL3+1)
      parameter (pgHexaH2=PgHexaH1+1)
      parameter (pgHexaH3=PgHexaH2+1)
      parameter (pgHexaH4=PgHexaH3+1)
      parameter (pgHexaH5=PgHexaH4+1)
      parameter (pgRhomboL1=PgHexaH5+1)
      parameter (pgRhomboL2=PgRhomboL1+1)
      parameter (pgRhomboH1=PgRhomboL2+1)
      parameter (pgRhomboH2=PgRhomboH1+1)
      parameter (pgRhomboH3=PgRhomboH2+1)
      parameter (pgCubicL1=PgRhomboH3+1)
      parameter (pgCubicL2=PgCubicL1+1)
      parameter (pgCubicH1=PgCubicL2+1)
      parameter (pgCubicH2=PgCubicH1+1)
      parameter (pgCubicH3=PgCubicH2+1)
      integer maxpg
      parameter (maxpg=pgCubicH3)
      integer pgTriclFirst
      integer pgTriclLast
      integer pgMonoFirst
      integer pgMonoLast
      integer pgOrthoFirst
      integer pgOrthoLast
      integer pgTetraLfirst
      integer pgTetraLlast
      integer pgTetraHfirst
      integer pgTetraHlast
      integer pgTrigoLfirst
      integer pgTrigoLlast
      integer pgTrigoHfirst
      integer pgTrigoHlast
      integer pgHexaLfirst
      integer pgHexaLlast
      integer pgHexaHfirst
      integer pgHexaHlast
      integer pgRhomboLfirst
      integer pgRhomboLlast
      integer pgRhomboHfirst
      integer pgRhomboHlast
      integer pgCubicLfirst
      integer pgCubicLlast
      integer pgCubicHfirst
      integer pgCubicHlast
      parameter(pgTriclFirst=pgTricl1)
      parameter(pgTriclLast=pgTricl2)
      parameter(pgMonoFirst=pgMono1)
      parameter(pgMonoLast=pgMono9)
      parameter(pgOrthoFirst=pgOrtho1)
      parameter(pgOrthoLast=pgOrtho5)
      parameter(pgTetraLfirst=pgTetraL1)
      parameter(pgTetraLlast=pgTetraL3)
      parameter(pgTetraHfirst=pgTetraH1)
      parameter(pgTetraHlast=pgTetraH5)
      parameter(pgTrigoLfirst=pgTrigoL1)
      parameter(pgTrigoLlast=pgTrigoL2)
      parameter(pgTrigoHfirst=pgTrigoH1)
      parameter(pgTrigoHlast=pgTrigoH6)
      parameter(pgHexaLfirst=pgHexaL1)
      parameter(pgHexaLlast=pgHexaL3)
      parameter(pgHexaHfirst=pgHexaH1)
      parameter(pgHexaHlast=pgHexaH5)
      parameter(pgRhomboLfirst=pgRhomboL1)
      parameter(pgRhomboLlast=pgRhomboL2)
      parameter(pgRhomboHfirst=pgRhomboH1)
      parameter(pgRhomboHlast=pgRhomboH3)
      parameter(pgCubicLfirst=pgCubicL1)
      parameter(pgCubicLlast=pgCubicL2)
      parameter(pgCubicHfirst=pgCubicH1)
      parameter(pgCubicHlast=pgCubicH3)
      integer CurrentSymbol
      logical Centric
      integer nPgQvec
      integer npg
      integer npgAcentric
      integer pgMatrixList(3,3,49)
      integer pgQvecMatrixList(3,3,49)
      integer pgMatrixListAcentric(3,3,49)
      integer pgQvecMatrixListAcentric(3,3,49)
      common /common_symm/ CurrentSymbol,centric,nPgQvec,npg,
     + npgAcentric,pgMatrixList,pgQvecMatrixList,pgMatrixListAcentric,
     + pgQvecMatrixListAcentric
      character pgnames(maxpg)*6
      common /common_symm_char/ pgnames
      data pgnames /'1','-1',   ! tricl
     +     '2','m','2/m','211','m11','2/m11','112','11m','112/m',       ! mono
     +     '222','mm2','2mm','m2m','mmm', ! ortho
     +     '4','-4','4/m',      ! tetraL
     +     '422','4mm','-42m','-4m2','4/mmm', ! tetraH
     +     '3','-3',            ! trigoL
     +     '312','321','31m','3m1','-31m','-3m1', ! trigoH
     +     '6','-6','6/m',      ! hexaL
     +     '622','6mm','-6m2','-62m','6/mmm', ! hexaH
     +     'R3','R-3',          ! rhomboL
     +     'R32','R3m','R-3m',  ! rhomboH
     +     '23','m3',           ! cubicL
     +     '432','-43m','m3m'/  ! cubicH
      end
      subroutine pg2crystal(pg,crystal)
      character pg*(*)
      character crystal*(*)
      integer pgTricl1
      integer pgTricl2
      integer pgMono1
      integer pgMono2
      integer pgMono3
      integer pgMono4
      integer pgMono5
      integer pgMono6
      integer pgMono7
      integer pgMono8
      integer pgMono9
      integer pgOrtho1
      integer pgOrtho2
      integer pgOrtho3
      integer pgOrtho4
      integer pgOrtho5
      integer pgTetraL1
      integer pgTetraL2
      integer pgTetraL3
      integer pgTetraH1
      integer pgTetraH2
      integer pgTetraH3
      integer pgTetraH4
      integer pgTetraH5
      integer pgTrigoL1
      integer pgTrigoL2
      integer pgTrigoH1
      integer pgTrigoH2
      integer pgTrigoH3
      integer pgTrigoH4
      integer pgTrigoH5
      integer pgTrigoH6
      integer pgHexaL1
      integer pgHexaL2
      integer pgHexaL3
      integer pgHexaH1
      integer pgHexaH2
      integer pgHexaH3
      integer pgHexaH4
      integer pgHexaH5
      integer pgRhomboL1
      integer pgRhomboL2
      integer pgRhomboH1
      integer pgRhomboH2
      integer pgRhomboH3
      integer pgCubicL1
      integer pgCubicL2
      integer pgCubicH1
      integer pgCubicH2
      integer pgCubicH3
      parameter (pgTricl1=1)
      parameter (pgTricl2=pgTricl1+1)
      parameter (pgMono1=pgTricl2+1)
      parameter (pgMono2=pgMono1+1)
      parameter (pgMono3=pgMono2+1)
      parameter (pgMono4=pgMono3+1)
      parameter (pgMono5=pgMono4+1)
      parameter (pgMono6=pgMono5+1)
      parameter (pgMono7=pgMono6+1)
      parameter (pgMono8=pgMono7+1)
      parameter (pgMono9=pgMono8+1)
      parameter (pgOrtho1=pgMono9+1)
      parameter (pgOrtho2=pgOrtho1+1)
      parameter (pgOrtho3=pgOrtho2+1)
      parameter (pgOrtho4=pgOrtho3+1)
      parameter (pgOrtho5=pgOrtho4+1)
      parameter (pgTetraL1=pgOrtho5+1)
      parameter (pgTetraL2=pgTetraL1+1)
      parameter (pgTetraL3=pgTetraL2+1)
      parameter (pgTetraH1=pgTetraL3+1)
      parameter (pgTetraH2=pgTetraH1+1)
      parameter (pgTetraH3=pgTetraH2+1)
      parameter (pgTetraH4=pgTetraH3+1)
      parameter (pgTetraH5=pgTetraH4+1)
      parameter (pgTrigoL1=pgTetraH5+1)
      parameter (pgTrigoL2=pgTrigoL1+1)
      parameter (pgTrigoH1=pgTrigoL2+1)
      parameter (pgTrigoH2=pgTrigoH1+1)
      parameter (pgTrigoH3=pgTrigoH2+1)
      parameter (pgTrigoH4=pgTrigoH3+1)
      parameter (pgTrigoH5=pgTrigoH4+1)
      parameter (pgTrigoH6=pgTrigoH5+1)
      parameter (pgHexaL1=pgTrigoH6+1)
      parameter (pgHexaL2=pgHexaL1+1)
      parameter (pgHexaL3=pgHexaL2+1)
      parameter (pgHexaH1=PgHexaL3+1)
      parameter (pgHexaH2=PgHexaH1+1)
      parameter (pgHexaH3=PgHexaH2+1)
      parameter (pgHexaH4=PgHexaH3+1)
      parameter (pgHexaH5=PgHexaH4+1)
      parameter (pgRhomboL1=PgHexaH5+1)
      parameter (pgRhomboL2=PgRhomboL1+1)
      parameter (pgRhomboH1=PgRhomboL2+1)
      parameter (pgRhomboH2=PgRhomboH1+1)
      parameter (pgRhomboH3=PgRhomboH2+1)
      parameter (pgCubicL1=PgRhomboH3+1)
      parameter (pgCubicL2=PgCubicL1+1)
      parameter (pgCubicH1=PgCubicL2+1)
      parameter (pgCubicH2=PgCubicH1+1)
      parameter (pgCubicH3=PgCubicH2+1)
      integer maxpg
      parameter (maxpg=pgCubicH3)
      integer pgTriclFirst
      integer pgTriclLast
      integer pgMonoFirst
      integer pgMonoLast
      integer pgOrthoFirst
      integer pgOrthoLast
      integer pgTetraLfirst
      integer pgTetraLlast
      integer pgTetraHfirst
      integer pgTetraHlast
      integer pgTrigoLfirst
      integer pgTrigoLlast
      integer pgTrigoHfirst
      integer pgTrigoHlast
      integer pgHexaLfirst
      integer pgHexaLlast
      integer pgHexaHfirst
      integer pgHexaHlast
      integer pgRhomboLfirst
      integer pgRhomboLlast
      integer pgRhomboHfirst
      integer pgRhomboHlast
      integer pgCubicLfirst
      integer pgCubicLlast
      integer pgCubicHfirst
      integer pgCubicHlast
      parameter(pgTriclFirst=pgTricl1)
      parameter(pgTriclLast=pgTricl2)
      parameter(pgMonoFirst=pgMono1)
      parameter(pgMonoLast=pgMono9)
      parameter(pgOrthoFirst=pgOrtho1)
      parameter(pgOrthoLast=pgOrtho5)
      parameter(pgTetraLfirst=pgTetraL1)
      parameter(pgTetraLlast=pgTetraL3)
      parameter(pgTetraHfirst=pgTetraH1)
      parameter(pgTetraHlast=pgTetraH5)
      parameter(pgTrigoLfirst=pgTrigoL1)
      parameter(pgTrigoLlast=pgTrigoL2)
      parameter(pgTrigoHfirst=pgTrigoH1)
      parameter(pgTrigoHlast=pgTrigoH6)
      parameter(pgHexaLfirst=pgHexaL1)
      parameter(pgHexaLlast=pgHexaL3)
      parameter(pgHexaHfirst=pgHexaH1)
      parameter(pgHexaHlast=pgHexaH5)
      parameter(pgRhomboLfirst=pgRhomboL1)
      parameter(pgRhomboLlast=pgRhomboL2)
      parameter(pgRhomboHfirst=pgRhomboH1)
      parameter(pgRhomboHlast=pgRhomboH3)
      parameter(pgCubicLfirst=pgCubicL1)
      parameter(pgCubicLlast=pgCubicL2)
      parameter(pgCubicHfirst=pgCubicH1)
      parameter(pgCubicHlast=pgCubicH3)
      integer CurrentSymbol
      logical Centric
      integer nPgQvec
      integer npg
      integer npgAcentric
      integer pgMatrixList(3,3,49)
      integer pgQvecMatrixList(3,3,49)
      integer pgMatrixListAcentric(3,3,49)
      integer pgQvecMatrixListAcentric(3,3,49)
      common /common_symm/ CurrentSymbol,centric,nPgQvec,npg,
     + npgAcentric,pgMatrixList,pgQvecMatrixList,pgMatrixListAcentric,
     + pgQvecMatrixListAcentric
      character pgnames(maxpg)*6
      common /common_symm_char/ pgnames
      integer old
      call pgsymbol(pg,old)
      if(old.ge.pgTriclfirst.and.old.le.pgTricllast) then
        crystal='triclinic'
      else if(old.ge.pgMonofirst.and.old.le.pgMonolast) then
        crystal = 'monoclinic'
      else if(old.ge.pgOrthofirst.and.old.le.pgOrtholast) then
        crystal = 'orthorhombic'
      else if(old.ge.pgTetraLfirst.and.old.le.pgTetraHlast) then
        crystal = 'tetragonal'
      else if(old.ge.pgTrigoLfirst.and.old.le.pgTrigoHlast) then
        crystal = 'trigonal'
      else if(old.ge.pgHexaLfirst.and.old.le.pgHexaHlast) then
        crystal = 'hexagonal'
      else if(old.ge.pgRhomboLfirst.and.old.le.pgRhomboHlast) then
        crystal = 'rhombohedral'
      else if(old.ge.pgCubicLfirst.and.old.le.pgCubicHlast) then
        crystal = 'cubic'
      else
        crystal = 'unknown'
      endif
      return
      end                       ! pg2crystal
      subroutine pgLong(symbol,long)
      integer   symbol
      character long*(*)
      integer pgTricl1
      integer pgTricl2
      integer pgMono1
      integer pgMono2
      integer pgMono3
      integer pgMono4
      integer pgMono5
      integer pgMono6
      integer pgMono7
      integer pgMono8
      integer pgMono9
      integer pgOrtho1
      integer pgOrtho2
      integer pgOrtho3
      integer pgOrtho4
      integer pgOrtho5
      integer pgTetraL1
      integer pgTetraL2
      integer pgTetraL3
      integer pgTetraH1
      integer pgTetraH2
      integer pgTetraH3
      integer pgTetraH4
      integer pgTetraH5
      integer pgTrigoL1
      integer pgTrigoL2
      integer pgTrigoH1
      integer pgTrigoH2
      integer pgTrigoH3
      integer pgTrigoH4
      integer pgTrigoH5
      integer pgTrigoH6
      integer pgHexaL1
      integer pgHexaL2
      integer pgHexaL3
      integer pgHexaH1
      integer pgHexaH2
      integer pgHexaH3
      integer pgHexaH4
      integer pgHexaH5
      integer pgRhomboL1
      integer pgRhomboL2
      integer pgRhomboH1
      integer pgRhomboH2
      integer pgRhomboH3
      integer pgCubicL1
      integer pgCubicL2
      integer pgCubicH1
      integer pgCubicH2
      integer pgCubicH3
      parameter (pgTricl1=1)
      parameter (pgTricl2=pgTricl1+1)
      parameter (pgMono1=pgTricl2+1)
      parameter (pgMono2=pgMono1+1)
      parameter (pgMono3=pgMono2+1)
      parameter (pgMono4=pgMono3+1)
      parameter (pgMono5=pgMono4+1)
      parameter (pgMono6=pgMono5+1)
      parameter (pgMono7=pgMono6+1)
      parameter (pgMono8=pgMono7+1)
      parameter (pgMono9=pgMono8+1)
      parameter (pgOrtho1=pgMono9+1)
      parameter (pgOrtho2=pgOrtho1+1)
      parameter (pgOrtho3=pgOrtho2+1)
      parameter (pgOrtho4=pgOrtho3+1)
      parameter (pgOrtho5=pgOrtho4+1)
      parameter (pgTetraL1=pgOrtho5+1)
      parameter (pgTetraL2=pgTetraL1+1)
      parameter (pgTetraL3=pgTetraL2+1)
      parameter (pgTetraH1=pgTetraL3+1)
      parameter (pgTetraH2=pgTetraH1+1)
      parameter (pgTetraH3=pgTetraH2+1)
      parameter (pgTetraH4=pgTetraH3+1)
      parameter (pgTetraH5=pgTetraH4+1)
      parameter (pgTrigoL1=pgTetraH5+1)
      parameter (pgTrigoL2=pgTrigoL1+1)
      parameter (pgTrigoH1=pgTrigoL2+1)
      parameter (pgTrigoH2=pgTrigoH1+1)
      parameter (pgTrigoH3=pgTrigoH2+1)
      parameter (pgTrigoH4=pgTrigoH3+1)
      parameter (pgTrigoH5=pgTrigoH4+1)
      parameter (pgTrigoH6=pgTrigoH5+1)
      parameter (pgHexaL1=pgTrigoH6+1)
      parameter (pgHexaL2=pgHexaL1+1)
      parameter (pgHexaL3=pgHexaL2+1)
      parameter (pgHexaH1=PgHexaL3+1)
      parameter (pgHexaH2=PgHexaH1+1)
      parameter (pgHexaH3=PgHexaH2+1)
      parameter (pgHexaH4=PgHexaH3+1)
      parameter (pgHexaH5=PgHexaH4+1)
      parameter (pgRhomboL1=PgHexaH5+1)
      parameter (pgRhomboL2=PgRhomboL1+1)
      parameter (pgRhomboH1=PgRhomboL2+1)
      parameter (pgRhomboH2=PgRhomboH1+1)
      parameter (pgRhomboH3=PgRhomboH2+1)
      parameter (pgCubicL1=PgRhomboH3+1)
      parameter (pgCubicL2=PgCubicL1+1)
      parameter (pgCubicH1=PgCubicL2+1)
      parameter (pgCubicH2=PgCubicH1+1)
      parameter (pgCubicH3=PgCubicH2+1)
      integer maxpg
      parameter (maxpg=pgCubicH3)
      integer pgTriclFirst
      integer pgTriclLast
      integer pgMonoFirst
      integer pgMonoLast
      integer pgOrthoFirst
      integer pgOrthoLast
      integer pgTetraLfirst
      integer pgTetraLlast
      integer pgTetraHfirst
      integer pgTetraHlast
      integer pgTrigoLfirst
      integer pgTrigoLlast
      integer pgTrigoHfirst
      integer pgTrigoHlast
      integer pgHexaLfirst
      integer pgHexaLlast
      integer pgHexaHfirst
      integer pgHexaHlast
      integer pgRhomboLfirst
      integer pgRhomboLlast
      integer pgRhomboHfirst
      integer pgRhomboHlast
      integer pgCubicLfirst
      integer pgCubicLlast
      integer pgCubicHfirst
      integer pgCubicHlast
      parameter(pgTriclFirst=pgTricl1)
      parameter(pgTriclLast=pgTricl2)
      parameter(pgMonoFirst=pgMono1)
      parameter(pgMonoLast=pgMono9)
      parameter(pgOrthoFirst=pgOrtho1)
      parameter(pgOrthoLast=pgOrtho5)
      parameter(pgTetraLfirst=pgTetraL1)
      parameter(pgTetraLlast=pgTetraL3)
      parameter(pgTetraHfirst=pgTetraH1)
      parameter(pgTetraHlast=pgTetraH5)
      parameter(pgTrigoLfirst=pgTrigoL1)
      parameter(pgTrigoLlast=pgTrigoL2)
      parameter(pgTrigoHfirst=pgTrigoH1)
      parameter(pgTrigoHlast=pgTrigoH6)
      parameter(pgHexaLfirst=pgHexaL1)
      parameter(pgHexaLlast=pgHexaL3)
      parameter(pgHexaHfirst=pgHexaH1)
      parameter(pgHexaHlast=pgHexaH5)
      parameter(pgRhomboLfirst=pgRhomboL1)
      parameter(pgRhomboLlast=pgRhomboL2)
      parameter(pgRhomboHfirst=pgRhomboH1)
      parameter(pgRhomboHlast=pgRhomboH3)
      parameter(pgCubicLfirst=pgCubicL1)
      parameter(pgCubicLlast=pgCubicL2)
      parameter(pgCubicHfirst=pgCubicH1)
      parameter(pgCubicHlast=pgCubicH3)
      integer CurrentSymbol
      logical Centric
      integer nPgQvec
      integer npg
      integer npgAcentric
      integer pgMatrixList(3,3,49)
      integer pgQvecMatrixList(3,3,49)
      integer pgMatrixListAcentric(3,3,49)
      integer pgQvecMatrixListAcentric(3,3,49)
      common /common_symm/ CurrentSymbol,centric,nPgQvec,npg,
     + npgAcentric,pgMatrixList,pgQvecMatrixList,pgMatrixListAcentric,
     + pgQvecMatrixListAcentric
      character pgnames(maxpg)*6
      common /common_symm_char/ pgnames
      character string*30
      character short*6
      call pgShort(symbol,short)
      if(symbol.ge.pgTriclfirst.and.symbol.le.pgTricllast) then
        string = 'Triclinic'
      else if(symbol.ge.pgMonofirst.and.symbol.le.pgMonolast) then
        string = 'Monoclinic'
      else if(symbol.ge.pgOrthofirst.and.symbol.le.pgOrtholast) then
        string = 'Orthorhombic'
      else if(symbol.ge.pgTetraLfirst.and.symbol.le.pgTetraLLast) then
        string = 'Tetragonal low'
      else if(symbol.ge.pgTetraHfirst.and.symbol.le.pgTetraHlast) then
        string = 'Tetragonal high'
      else if(symbol.ge.pgTrigoLfirst.and.symbol.le.pgTrigoLlast) then
        string = 'Trigonal low'
      else if(symbol.ge.pgTrigoHfirst.and.symbol.le.pgTrigoHlast) then
        string = 'Trigonal high'
      else if(symbol.ge.pgRhomboLfirst.and.symbol.le.pgRhomboLlast) then
        string = 'Rhombohedral low'
      else if(symbol.ge.pgRhomboHfirst.and.symbol.le.pgRhomboHlast) then
        string = 'Rhombohedral high'
      else if(symbol.ge.pgHexaLfirst.and.symbol.le.pgHexaLlast) then
        string = 'Hexagonal low'
      else if(symbol.ge.pgHexaHfirst.and.symbol.le.pgHexaHlast) then
        string = 'Hexagonal high'
      else if(symbol.ge.pgCubicLfirst.and.symbol.le.pgCubicLlast) then
        string = 'Cubic low'
      else if(symbol.ge.pgCubicHfirst.and.symbol.le.pgCubicHlast) then
        string = 'Cubic high'
      else
        string = 'unknown'
      endif
      write(long,100) short,string
  100 format(a,1x,a)
      return
      end                       ! PgLong
      subroutine PgShort(symbol,short)
      character short*(*)
      integer pgTricl1
      integer pgTricl2
      integer pgMono1
      integer pgMono2
      integer pgMono3
      integer pgMono4
      integer pgMono5
      integer pgMono6
      integer pgMono7
      integer pgMono8
      integer pgMono9
      integer pgOrtho1
      integer pgOrtho2
      integer pgOrtho3
      integer pgOrtho4
      integer pgOrtho5
      integer pgTetraL1
      integer pgTetraL2
      integer pgTetraL3
      integer pgTetraH1
      integer pgTetraH2
      integer pgTetraH3
      integer pgTetraH4
      integer pgTetraH5
      integer pgTrigoL1
      integer pgTrigoL2
      integer pgTrigoH1
      integer pgTrigoH2
      integer pgTrigoH3
      integer pgTrigoH4
      integer pgTrigoH5
      integer pgTrigoH6
      integer pgHexaL1
      integer pgHexaL2
      integer pgHexaL3
      integer pgHexaH1
      integer pgHexaH2
      integer pgHexaH3
      integer pgHexaH4
      integer pgHexaH5
      integer pgRhomboL1
      integer pgRhomboL2
      integer pgRhomboH1
      integer pgRhomboH2
      integer pgRhomboH3
      integer pgCubicL1
      integer pgCubicL2
      integer pgCubicH1
      integer pgCubicH2
      integer pgCubicH3
      parameter (pgTricl1=1)
      parameter (pgTricl2=pgTricl1+1)
      parameter (pgMono1=pgTricl2+1)
      parameter (pgMono2=pgMono1+1)
      parameter (pgMono3=pgMono2+1)
      parameter (pgMono4=pgMono3+1)
      parameter (pgMono5=pgMono4+1)
      parameter (pgMono6=pgMono5+1)
      parameter (pgMono7=pgMono6+1)
      parameter (pgMono8=pgMono7+1)
      parameter (pgMono9=pgMono8+1)
      parameter (pgOrtho1=pgMono9+1)
      parameter (pgOrtho2=pgOrtho1+1)
      parameter (pgOrtho3=pgOrtho2+1)
      parameter (pgOrtho4=pgOrtho3+1)
      parameter (pgOrtho5=pgOrtho4+1)
      parameter (pgTetraL1=pgOrtho5+1)
      parameter (pgTetraL2=pgTetraL1+1)
      parameter (pgTetraL3=pgTetraL2+1)
      parameter (pgTetraH1=pgTetraL3+1)
      parameter (pgTetraH2=pgTetraH1+1)
      parameter (pgTetraH3=pgTetraH2+1)
      parameter (pgTetraH4=pgTetraH3+1)
      parameter (pgTetraH5=pgTetraH4+1)
      parameter (pgTrigoL1=pgTetraH5+1)
      parameter (pgTrigoL2=pgTrigoL1+1)
      parameter (pgTrigoH1=pgTrigoL2+1)
      parameter (pgTrigoH2=pgTrigoH1+1)
      parameter (pgTrigoH3=pgTrigoH2+1)
      parameter (pgTrigoH4=pgTrigoH3+1)
      parameter (pgTrigoH5=pgTrigoH4+1)
      parameter (pgTrigoH6=pgTrigoH5+1)
      parameter (pgHexaL1=pgTrigoH6+1)
      parameter (pgHexaL2=pgHexaL1+1)
      parameter (pgHexaL3=pgHexaL2+1)
      parameter (pgHexaH1=PgHexaL3+1)
      parameter (pgHexaH2=PgHexaH1+1)
      parameter (pgHexaH3=PgHexaH2+1)
      parameter (pgHexaH4=PgHexaH3+1)
      parameter (pgHexaH5=PgHexaH4+1)
      parameter (pgRhomboL1=PgHexaH5+1)
      parameter (pgRhomboL2=PgRhomboL1+1)
      parameter (pgRhomboH1=PgRhomboL2+1)
      parameter (pgRhomboH2=PgRhomboH1+1)
      parameter (pgRhomboH3=PgRhomboH2+1)
      parameter (pgCubicL1=PgRhomboH3+1)
      parameter (pgCubicL2=PgCubicL1+1)
      parameter (pgCubicH1=PgCubicL2+1)
      parameter (pgCubicH2=PgCubicH1+1)
      parameter (pgCubicH3=PgCubicH2+1)
      integer maxpg
      parameter (maxpg=pgCubicH3)
      integer pgTriclFirst
      integer pgTriclLast
      integer pgMonoFirst
      integer pgMonoLast
      integer pgOrthoFirst
      integer pgOrthoLast
      integer pgTetraLfirst
      integer pgTetraLlast
      integer pgTetraHfirst
      integer pgTetraHlast
      integer pgTrigoLfirst
      integer pgTrigoLlast
      integer pgTrigoHfirst
      integer pgTrigoHlast
      integer pgHexaLfirst
      integer pgHexaLlast
      integer pgHexaHfirst
      integer pgHexaHlast
      integer pgRhomboLfirst
      integer pgRhomboLlast
      integer pgRhomboHfirst
      integer pgRhomboHlast
      integer pgCubicLfirst
      integer pgCubicLlast
      integer pgCubicHfirst
      integer pgCubicHlast
      parameter(pgTriclFirst=pgTricl1)
      parameter(pgTriclLast=pgTricl2)
      parameter(pgMonoFirst=pgMono1)
      parameter(pgMonoLast=pgMono9)
      parameter(pgOrthoFirst=pgOrtho1)
      parameter(pgOrthoLast=pgOrtho5)
      parameter(pgTetraLfirst=pgTetraL1)
      parameter(pgTetraLlast=pgTetraL3)
      parameter(pgTetraHfirst=pgTetraH1)
      parameter(pgTetraHlast=pgTetraH5)
      parameter(pgTrigoLfirst=pgTrigoL1)
      parameter(pgTrigoLlast=pgTrigoL2)
      parameter(pgTrigoHfirst=pgTrigoH1)
      parameter(pgTrigoHlast=pgTrigoH6)
      parameter(pgHexaLfirst=pgHexaL1)
      parameter(pgHexaLlast=pgHexaL3)
      parameter(pgHexaHfirst=pgHexaH1)
      parameter(pgHexaHlast=pgHexaH5)
      parameter(pgRhomboLfirst=pgRhomboL1)
      parameter(pgRhomboLlast=pgRhomboL2)
      parameter(pgRhomboHfirst=pgRhomboH1)
      parameter(pgRhomboHlast=pgRhomboH3)
      parameter(pgCubicLfirst=pgCubicL1)
      parameter(pgCubicLlast=pgCubicL2)
      parameter(pgCubicHfirst=pgCubicH1)
      parameter(pgCubicHlast=pgCubicH3)
      integer CurrentSymbol
      logical Centric
      integer nPgQvec
      integer npg
      integer npgAcentric
      integer pgMatrixList(3,3,49)
      integer pgQvecMatrixList(3,3,49)
      integer pgMatrixListAcentric(3,3,49)
      integer pgQvecMatrixListAcentric(3,3,49)
      common /common_symm/ CurrentSymbol,centric,nPgQvec,npg,
     + npgAcentric,pgMatrixList,pgQvecMatrixList,pgMatrixListAcentric,
     + pgQvecMatrixListAcentric
      character pgnames(maxpg)*6
      common /common_symm_char/ pgnames
      external lauexxx
      integer symbol
      if(symbol.ge.1.and.symbol.le.maxpg) then
        short = pgnames(symbol)
      else
        short = '?'
      endif
      return
      end                       ! PgShort
      subroutine PgString(short,long)
      character short*(*)
      character long*(*)
      integer   symbol
      call PgSymbol(short,symbol)
      call PgLong(symbol,long)
      return
      end                       ! PgString
      subroutine PgSymbol(inputpg,symbol)
      character inputpg*(*)
      integer   symbol
      integer pgTricl1
      integer pgTricl2
      integer pgMono1
      integer pgMono2
      integer pgMono3
      integer pgMono4
      integer pgMono5
      integer pgMono6
      integer pgMono7
      integer pgMono8
      integer pgMono9
      integer pgOrtho1
      integer pgOrtho2
      integer pgOrtho3
      integer pgOrtho4
      integer pgOrtho5
      integer pgTetraL1
      integer pgTetraL2
      integer pgTetraL3
      integer pgTetraH1
      integer pgTetraH2
      integer pgTetraH3
      integer pgTetraH4
      integer pgTetraH5
      integer pgTrigoL1
      integer pgTrigoL2
      integer pgTrigoH1
      integer pgTrigoH2
      integer pgTrigoH3
      integer pgTrigoH4
      integer pgTrigoH5
      integer pgTrigoH6
      integer pgHexaL1
      integer pgHexaL2
      integer pgHexaL3
      integer pgHexaH1
      integer pgHexaH2
      integer pgHexaH3
      integer pgHexaH4
      integer pgHexaH5
      integer pgRhomboL1
      integer pgRhomboL2
      integer pgRhomboH1
      integer pgRhomboH2
      integer pgRhomboH3
      integer pgCubicL1
      integer pgCubicL2
      integer pgCubicH1
      integer pgCubicH2
      integer pgCubicH3
      parameter (pgTricl1=1)
      parameter (pgTricl2=pgTricl1+1)
      parameter (pgMono1=pgTricl2+1)
      parameter (pgMono2=pgMono1+1)
      parameter (pgMono3=pgMono2+1)
      parameter (pgMono4=pgMono3+1)
      parameter (pgMono5=pgMono4+1)
      parameter (pgMono6=pgMono5+1)
      parameter (pgMono7=pgMono6+1)
      parameter (pgMono8=pgMono7+1)
      parameter (pgMono9=pgMono8+1)
      parameter (pgOrtho1=pgMono9+1)
      parameter (pgOrtho2=pgOrtho1+1)
      parameter (pgOrtho3=pgOrtho2+1)
      parameter (pgOrtho4=pgOrtho3+1)
      parameter (pgOrtho5=pgOrtho4+1)
      parameter (pgTetraL1=pgOrtho5+1)
      parameter (pgTetraL2=pgTetraL1+1)
      parameter (pgTetraL3=pgTetraL2+1)
      parameter (pgTetraH1=pgTetraL3+1)
      parameter (pgTetraH2=pgTetraH1+1)
      parameter (pgTetraH3=pgTetraH2+1)
      parameter (pgTetraH4=pgTetraH3+1)
      parameter (pgTetraH5=pgTetraH4+1)
      parameter (pgTrigoL1=pgTetraH5+1)
      parameter (pgTrigoL2=pgTrigoL1+1)
      parameter (pgTrigoH1=pgTrigoL2+1)
      parameter (pgTrigoH2=pgTrigoH1+1)
      parameter (pgTrigoH3=pgTrigoH2+1)
      parameter (pgTrigoH4=pgTrigoH3+1)
      parameter (pgTrigoH5=pgTrigoH4+1)
      parameter (pgTrigoH6=pgTrigoH5+1)
      parameter (pgHexaL1=pgTrigoH6+1)
      parameter (pgHexaL2=pgHexaL1+1)
      parameter (pgHexaL3=pgHexaL2+1)
      parameter (pgHexaH1=PgHexaL3+1)
      parameter (pgHexaH2=PgHexaH1+1)
      parameter (pgHexaH3=PgHexaH2+1)
      parameter (pgHexaH4=PgHexaH3+1)
      parameter (pgHexaH5=PgHexaH4+1)
      parameter (pgRhomboL1=PgHexaH5+1)
      parameter (pgRhomboL2=PgRhomboL1+1)
      parameter (pgRhomboH1=PgRhomboL2+1)
      parameter (pgRhomboH2=PgRhomboH1+1)
      parameter (pgRhomboH3=PgRhomboH2+1)
      parameter (pgCubicL1=PgRhomboH3+1)
      parameter (pgCubicL2=PgCubicL1+1)
      parameter (pgCubicH1=PgCubicL2+1)
      parameter (pgCubicH2=PgCubicH1+1)
      parameter (pgCubicH3=PgCubicH2+1)
      integer maxpg
      parameter (maxpg=pgCubicH3)
      integer pgTriclFirst
      integer pgTriclLast
      integer pgMonoFirst
      integer pgMonoLast
      integer pgOrthoFirst
      integer pgOrthoLast
      integer pgTetraLfirst
      integer pgTetraLlast
      integer pgTetraHfirst
      integer pgTetraHlast
      integer pgTrigoLfirst
      integer pgTrigoLlast
      integer pgTrigoHfirst
      integer pgTrigoHlast
      integer pgHexaLfirst
      integer pgHexaLlast
      integer pgHexaHfirst
      integer pgHexaHlast
      integer pgRhomboLfirst
      integer pgRhomboLlast
      integer pgRhomboHfirst
      integer pgRhomboHlast
      integer pgCubicLfirst
      integer pgCubicLlast
      integer pgCubicHfirst
      integer pgCubicHlast
      parameter(pgTriclFirst=pgTricl1)
      parameter(pgTriclLast=pgTricl2)
      parameter(pgMonoFirst=pgMono1)
      parameter(pgMonoLast=pgMono9)
      parameter(pgOrthoFirst=pgOrtho1)
      parameter(pgOrthoLast=pgOrtho5)
      parameter(pgTetraLfirst=pgTetraL1)
      parameter(pgTetraLlast=pgTetraL3)
      parameter(pgTetraHfirst=pgTetraH1)
      parameter(pgTetraHlast=pgTetraH5)
      parameter(pgTrigoLfirst=pgTrigoL1)
      parameter(pgTrigoLlast=pgTrigoL2)
      parameter(pgTrigoHfirst=pgTrigoH1)
      parameter(pgTrigoHlast=pgTrigoH6)
      parameter(pgHexaLfirst=pgHexaL1)
      parameter(pgHexaLlast=pgHexaL3)
      parameter(pgHexaHfirst=pgHexaH1)
      parameter(pgHexaHlast=pgHexaH5)
      parameter(pgRhomboLfirst=pgRhomboL1)
      parameter(pgRhomboLlast=pgRhomboL2)
      parameter(pgRhomboHfirst=pgRhomboH1)
      parameter(pgRhomboHlast=pgRhomboH3)
      parameter(pgCubicLfirst=pgCubicL1)
      parameter(pgCubicLlast=pgCubicL2)
      parameter(pgCubicHfirst=pgCubicH1)
      parameter(pgCubicHlast=pgCubicH3)
      integer CurrentSymbol
      logical Centric
      integer nPgQvec
      integer npg
      integer npgAcentric
      integer pgMatrixList(3,3,49)
      integer pgQvecMatrixList(3,3,49)
      integer pgMatrixListAcentric(3,3,49)
      integer pgQvecMatrixListAcentric(3,3,49)
      common /common_symm/ CurrentSymbol,centric,nPgQvec,npg,
     + npgAcentric,pgMatrixList,pgQvecMatrixList,pgMatrixListAcentric,
     + pgQvecMatrixListAcentric
      character pgnames(maxpg)*6
      common /common_symm_char/ pgnames
      external lauexxx
      integer i
      character pg1*6
      character pg2*6
      call lowercase(inputpg,pg1)
      if(pg1.eq.'m-3') then
        pg1 = 'm3'
      else if(pg1.eq.'m-3m') then
        pg1 = 'm3m'
      endif
      do i=1,maxpg
        call lowercase(pgnames(i),pg2)
        if(pg1.eq.pg2) then
          symbol = i
          return
        endif
      enddo
      if(pg1.eq.'mb'.or.pg1.eq.'m') then
        symbol = pgMono3
      else if(pg1.eq.'ma') then
        symbol = pgMono6
      else if(pg1.eq.'mc') then
        symbol = pgMono9
      else if(pg1.eq.'o') then
        symbol = pgOrtholast
      else if(pg1.eq.'tl'.or.pg1.eq.'t') then
        symbol = pgTetraLlast
      else if(pg1.eq.'th') then
        symbol = pgTetraHlast
      else if(pg1.eq.'hl'.or.pg1.eq.'h') then
        symbol = pgHexaLlast
      else if(pg1.eq.'hh') then
        symbol = pgHexaHlast
      else if(pg1.eq.'rl'.or.pg1.eq.'r') then
        symbol = pgRhomboLlast
      else if(pg1.eq.'rh') then
        symbol = pgRhomboHlast
      else if(pg1.eq.'cl'.or.pg1.eq.'c') then
        symbol = pgCubicLlast
      else if(pg1.eq.'ch') then
        symbol = pgCubicHlast
      else
        symbol = 0
      endif
      return
      end                       ! PgSymbol
      subroutine PrintRmat(out,nr,message,ier)
      integer   out             ! input
      integer   nr              ! input
      character message*(*)     ! output
      integer   ier             ! output
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer activermat
      logical DoRmatTrans
      logical TmatIsRealList(maxnrmat)
      real    reducedrmatlist(3,3,maxnrmat)
      real    rmatlist(3,3,maxnrmat)
      real    dmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,TmatIsRealList,
     +     reducedrmatlist,rmatlist,dmatlist,tmatlist,sigmacelllist,
     +     sigmavolumelist
      character rmatbravaislist(maxnrmat)*2
      character bravaislist(maxnrmat)*2
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer QvecTypes(maxnrmat)
      integer nqveclist(maxnrmat)
      real    qvecradiuslist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      logical nqvpautolist(maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      logical qvpactivelist(maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/QvecTypes,nqveclist,qvecradiuslist,
     +     qvvectorlist,qvorderlist,nqvpautolist,nqvplist,qvplist,
     +     qvpactivelist,qvphkllist
      external  rmatxxx
      integer   length
      integer   saveactivermat
      integer   i
      integer   j
      integer   lm
      if(out.eq.6) call str_flush
      call CheckRmat(nr,ier)
      if(ier.ne.0) then
         call RmatMessage(nr,ier,message)
         return
      endif
      saveactivermat = activermat
      call Activatermat(nr,ier)
      if(ier.ne.0) then
         call RmatMessage(nr,ier,message)
         return
      endif
      call str_integer(nr,'RMAT #',message)
      call str_string_write(out,rmattitle,message)
      call write2mat(out,rmat,dmat,'RMAT','DMAT')
      call writecell(out,dmat,' ', 'cell from rmat')
      if(length(pg).gt.0) then
        call writecell(out,dmat,pg,'pg constrained')
      endif
      if(sigmacell(1).gt.0.0) then
        call sigmastring(sigmacell,sigmavolume,' ',message,lm)
        call str_write(out,message(1:lm))
      endif
      call str_2string(bravais,pg,'Bravais=# pg=#',message)
      call str_write(out,message)
      if(nqvec.gt.0) then
        message = 'Qvectype=# #'
        call str_integer(qvectype,message,message)
        call str_string(QvecTypeNames(QvecType),message,message)
        call str_write(out,message)
        if(qvecradius.gt.0.0) then
          call str_real_write(out,qvecradius,'QvecRadius=#')
        endif
        if(qvecradiusactive.gt.0.0) then
          call str_real_write(out,qvecradiusactive,'ActiveQvecRadius=#')
        endif
        write(out,600)
  600   format('QVEC    dh      dk      dl   Order')
        do i=1,nqvec
          write(out,610) i,(qvvector(j,i),j=1,3),qvorder(i)
  610     format(i4,3f8.4,i4)
        enddo
        if(nqvpauto) then
          call str_num_write(out,nqvp,'# generated QV Combination^')
        else
          call str_num_write(out,nqvp,'# explicit QV Combination^')
        endif
      endif
      call ActivateRmat(saveactivermat,ier)
      if(ier.ne.0) then
         call RmatMessage(saveactivermat,ier,message)
         return
      endif
      call str_2integer(nr,out,'cell # written to unit #',message)
      return
      end                       ! PrintRmat
      subroutine QVadd(v,order,message,ier)
      real      v(3)              ! input
      integer   order             ! input
      character message*(*)
      integer   ier
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      external  rmatxxx
      if(nqvec.ge.maxqvec) then
        call str_integer(maxqvec,'Too many QVECs. Max=#',message)
        ier = 1
        return
      endif
      if(QvecType.eq.QvecTypeNone) then
        QvecType = QvecTypeModulated
        call str_string(QvecTypeNames(QvecType),
     +       'Setting qvectype to #',message)
        call WarningMessage(message)
      endif
      nqvec = nqvec + 1
      call SaveVec(v,qvvector,nqvec)
      qvorder(nqvec) = order
      call str_integer(nqvec,'stored qvec #',message)
      ier = 0
      return
      end                       ! QVadd
      subroutine QVbuild(message,ier)
      character message*(*)
      integer   ier
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      external  rmatxxx
      integer indx(maxqvec)
      integer i
      if(nqvec.lt.1) then
        message = 'No qvecs defined'
        ier = 0
        return
      endif
      if(nqvp.ne.0) then
        call str_integer(nqvp,
     +       'QVBuild error. nqvp=# (should be zero)',message)
        ier = 1
        return
      endif
      nqvpauto = .true.
      do i=1,nqvec
        indx(i)=-qvorder(i)
      enddo
 10   continue
      call QVCadd(indx,message,ier)
      if(ier.gt.1) then
        call FatalMessage(message)
      endif
      do i=1,nqvec
        if(indx(i).lt.qvorder(i)) then
          indx(i) = indx(i) + 1
          goto 10
        endif
        indx(i) = -qvorder(i)
      enddo
      call str_num(nqvp,'Generated # qvector combination^',message)
      ier = 0
      return
      end                       ! QVBuild
      subroutine QVbuildHkl
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer   i
      integer   j
      real      hkl(3)
      integer   combi(maxqvec)
      do i=1,nqvp
        do j=1,nqvec
          combi(j) = qvp(j,i)
        enddo
        call QVcombi2hkl(combi,hkl)
        call savevec(hkl,qvphkl,i)
      enddo
      return
      end                       ! QVbuildhkl
      subroutine QVCadd(combi,message,ier)
      integer   combi(*)        ! input
      character message*(*)     ! output
      integer   ier             ! output 0=succes 1=ignored 2=error
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      external  rmatxxx
      logical   debug
      parameter (debug=.false.)
      real      absvec
      integer   i
      real      v(3)
      real      hkl(3)
      real      av
      if(qvecradiusactive.lt.0.0) then
        call SetQvecRadiusActive
      endif
      if(qvecradiusactive.gt.0.0) then
        call QVcombi2hkl(combi,hkl)
        call MatVec(rmat,hkl,v)
        av = absvec(v)          ! = 2sin(th)/lambda
        if(debug) then
          call str_iarray_out(nqvec,combi,'combi')
          call str_real_out(av,'radius #')
        endif
        if(av.gt.qvecradiusactive+1e-5) then
          if(debug) then
            call str_out('too large.')
            call str_flush
          endif
          ier = 1
          call str_2real(av,qvecradiusactive,
     +         'radius # too large(#). ignored. ',message)
          return
        endif
      endif
      if(nqvp.ge.maxqvp) then
        call str_integer(maxqvp,'Too many qvp. Maximum=#',
     +       message)
        ier = 2
        return
      endif
      nqvp = nqvp + 1
      if(debug) then
        call str_integer_out(nqvp,'=> #')
        call str_iarray_out(nqvec,combi,' ')
      endif
      do i=1,nqvec
        qvp(i,nqvp) = combi(i)
      enddo
      qvpactive(nqvp) = .true.
      ier = 0
      call str_integer(nqvp,'QVC stored at #',message)
      return
      end                       ! QVCadd
      subroutine QVCinput(inputline,message,ier)
      character inputline*(*)
      character message*(*)
      integer   ier             ! output 0=succes 1=ignored 2=error
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      external  rmatxxx
      character line*80
      character field*80
      integer   i
      integer   combi(maxqvec)
      integer   ll
      integer   lf
      call str_header(inputline,field,lf,line,ll) ! skip QVC
      i = 0
      do while(ll.gt.0)
        call str_header(line(1:ll),field,lf,line,ll)
        i = i + 1
        call get_integer(combi(i),field(1:lf))
      enddo
      if(i.ne.nqvec) then
        message = 'ERROR nqvec=# nqc=# in line'
        call str_2integer(nqvec,i,message,message)
        call str_string(inputline,message,message)
        ier = 1
        return
      endif
      call QVcadd(combi,message,ier)
      return
      end                       ! qvcinput
      subroutine QVcombi2hkl(combi,hkl)
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      external  rmatxxx
      integer combi(maxqvec)    ! input
      real    hkl(3)            ! output
      integer i
      real    v(3)
      call getvec(qvvector,1,v)
      call facIvec(combi(1),v,hkl)
      do i=2,nqvec
        call GetVec(qvvector,i,v)
        call facIvec(combi(i),v,v)
        call sumvec(hkl,v,hkl)
      enddo
      return
      end                       ! QVcombi2hkl
      subroutine ReadBuffered(string,ls,ier)
      character string*(*)
      integer   ls
      integer   ier
      integer maxbuf
      parameter (maxbuf=8192)
      integer nbytes
      integer nlines
      integer bp
      integer bsize
      common /common_shoebuf/ nbytes,nlines,bp,bsize
      character openfilename*80
      character buf*(maxbuf)
      common /common_shoebuf_char/ openfilename,buf
      integer   ll
      integer   lstart
      integer   space
      integer   i
      ll = len(string)
      lstart = 0
      ier = 0
      ls = 0
   10 continue
      lstart = lstart + 1
      space=ll-lstart+1
      if(bp.gt.bsize) then
        call dskbr(1,buf,maxbuf,ier)
        if(ier.lt.-1) return
        if(ier.gt.0) then
          bsize = ier
        else
          bsize = maxbuf
        endif
        nbytes = nbytes + bsize
        bp = 1
      endif
      if(ichar(buf(bp:bp)).eq.10) then
        if(lstart.lt.ll) string(lstart:) = ' '
        bp = bp + 1
        nlines = nlines + 1
        ier = 0
        return
      endif
      do i=bp+1,bsize
        if(ichar(buf(i:i)).eq.10) then
          nlines = nlines + 1
          if(space.gt.0) then
            if(i-bp.gt.space) then
              string(lstart:ll) = buf(bp:bp+space-1)
              ls = ls + space
            else
              string(lstart:) = buf(bp:i-1)
              ls = ls + i-bp
            endif
          endif
          ier = 0
          bp = i+1
          if(ichar(string(ls:ls)).eq.13) then
            string(ls:ls) = ' '
            ls = ls - 1
          endif
          return
        endif
      enddo
      if(bsize-bp.gt.space) then
        string(lstart:ll) = buf(bp:bp+space-1)
        ls = ls + space
        lstart = ll
      else
        string(lstart:) = buf(bp:bsize)
        ls = ls + bsize - bp + 1
        lstart = lstart + (bsize-bp+1) - 1
      endif
      bp = bsize+1
      goto 10
      end
      subroutine ReadRmat(unit,nr,globalline,message,ier)
      integer   unit
      integer   nr
      character globalline*(*)
      character message*(*)
      integer   ier
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      external  rmatxxx
      integer   length
      character line*80
      character uline*80
      character filename*80
      integer   i
      integer   j
      character field*20
      logical   rmatfound
      real      v(3)
      integer   order
      integer   lf
      integer   ll
      real      tm(3,3)
      call CheckRmat(nr,ier)
      if(ier.eq.RmatErrorRange) then
         call RmatMessage(nr,ier,message)
         return
      endif
      rmatavailable(nr) = .false.
      rmatfound = .false.
      if(unit.gt.0) then
        inquire(unit=unit,name=filename)
      else
        filename='bufferinput'
      endif
      call UnitMatrix(rmat)
      call UnitMatrix(reducedrmat)
      call RmatInit('P')
      ier = 0
      call copystr(globalline,line)
  100 format(a)
      do while(ier.eq.0)
        call upcase(line,uline)
        if(uline(1:4).eq.'RMAT') then
          call str_leading(line(6:),line)
          call copystr(line,rmatbravais)
          if(rmatbravais.eq.' ') rmatbravais = 'P'
          bravais = rmatbravais
          if(unit.gt.0) then
            ll = 0
            do i=1,3
              do j=1,3
                if(ll.eq.0) then
                  lf = 0
                  do while(lf.eq.0)
                    read(unit,'(a)',iostat=ier) line
                    if(ier.ne.0) then
                      call str_integer(ier,
     +                     'Error # new line RMAT',message)
                      goto 950
                    endif
                    call str_header(line,field,lf,line,ll)
                  enddo
                else
                  call str_header(line,field,lf,line,ll)
                endif
                call evaluate(field,.false.,reducedrmat(i,j),
     +               ier,message)
                if(ier.ne.0) then
                  call str_3integer(ier,i,j,
     +                 'Error # reading RMAT[#,#] (#)',message)
                  call str_string(field,message,message)
                  goto 950
                endif
              enddo
            enddo
          else
            do i=1,3
              call readbuffered(line,ll,ier)
              if(ier.ne.0) then
                call str_2integer(ier,i,
     +               'Error # reading RMAT line #',message)
                goto 950
              endif
              do j=1,3
                call str_header(line,field,lf,line,ll)
                call evaluate(field,.false.,reducedrmat(i,j),
     +               ier,message)
                if(ier.ne.0) then
                  call str_3integer(ier,i,j,
     +                 'Error # reading RMAT[#,#] (#)',message)
                  call str_string(field,message,message)
                  goto 950
                endif
              enddo
            enddo
          endif
          rmatfound = .true.
        else if(uline(1:5).eq.'SIGMA') then
          call str_header(line,field,lf,line,ll)
          read(line,*,iostat=ier) sigmacell,sigmavolume
        else if(uline(1:4).eq.'TMAT') then
          call str_extract(line,2,bravais)
          call str_extract(line,3,pg)
          if(bravais.eq.' ') bravais = 'P'
          if(unit.gt.0) then
            ll = 0
            do i=1,3
              do j=1,3
                if(ll.eq.0) then
                  lf = 0
                  do while(lf.eq.0)
                    read(unit,'(a)',iostat=ier) line
                    if(ier.ne.0) then
                      call str_integer(ier,
     +                     'Error # new line TMAT',message)
                      goto 950
                    endif
                    call str_header(line,field,lf,line,ll)
                  enddo
                else
                  call str_header(line,field,lf,line,ll)
                endif
                call evaluate(field,.false.,tm(i,j),ier,message)
                if(ier.ne.0) then
                  call str_3integer(ier,i,j,
     +                 'Error # reading TMAT[#,#] (#)',message)
                  call str_string(field,message,message)
                  goto 950
                endif
              enddo
            enddo
          else
            do i=1,3
              call readbuffered(line,ll,ier)
              if(ier.ne.0) then
                call str_2integer(ier,i,
     +               'Error # reading TMAT line #',message)
                goto 950
              endif
              do j=1,3
                call str_header(line,field,lf,line,ll)
                call evaluate(field,.false.,tm(i,j),ier,message)
                if(ier.ne.0) then
                  call str_3integer(ier,i,j,
     +                 'Error # reading TMAT[#,#] (#)',message)
                  call str_string(field,message,message)
                  goto 950
                endif
              enddo
            enddo
          endif
          if(TmatIsReal) then
            call str_out('propagating TMAT')
            call str_flush
            call write2mat(6,tmat,tm,'current TMAT','extra TMAT')
          endif
          call MatMat(tm,tmat,tmat)
          if(TmatIsReal) then
            call writemat(6,tmat,'resulting TMAT')
          endif
          TmatIsReal = .true.
        else if(uline(1:5).eq.'CELL ') then
          continue
        else if(uline(1:1).eq.'#') then
          continue
        else if(uline(1:9).eq.'QVECTYPE ') then
          call str_leading(uline(10:),uline)
          call SetQvecType(uline,message,ier)
          if(ier.ne.0) goto 950
        else if(uline(1:11).eq.'QVECRADIUS ') then
          call str_leading(uline(12:),uline)
          call get_real(qvecradius,uline)
          call str_real_out(qvecradius,'qvr')
        else if(uline(1:5).eq.'QVEC ') then
          if(QvecType.eq.QvecTypeNone) QvecType = QvecTypeModulated
          if(nqvp.ne.0) then
            call str_integer(nqvp,
     +           'QVEC encountered while # QVC already defined',message)
            call WarningMessage(message)
            nqvp = 0
          endif
          call str_header(uline,field,lf,uline,ll) ! skip QVEC
          do i=1,3
            call str_header(uline,field,lf,uline,ll)
            if(lf.eq.0) then
              call str_2integer(i,nqvp+1,
     +             'Error reading component # of QVEC #',message)
              goto 950
            endif
            call get_real(v(i),field(1:lf))
          enddo
          if(ll.gt.0) then
            call str_header(uline,field,lf,uline,ll)
            call get_integer(order,field(1:lf))
          else
            order = 0
          endif
          if(ier.ne.0) then
            call str_integer(ier,'Error # reading QVEC',message)
            goto 950
          endif
          call QVadd(v,order,message,ier)
          if(ier.ne.0) return
        else if(uline(1:4).eq.'QVC ') then
          call QVCinput(line,message,ier)
          if(ier.gt.1) return
          nqvpauto = .false.
        else if(length(line).gt.0) then
          globalline = line
          goto 200
        endif
        if(unit.gt.0) then
          read(unit,100,iostat=ier) line
        else
          call readbuffered(line,ll,ier)
        endif
      enddo
      globalline = ' '
  200 continue
      if(.not.rmatfound) then
        message = 'No rmatrix found in #'
        call str_string(filename,message,message)
        ier = 1
        goto 900
      endif
      call filescan(filename,'NAME',rmattitle,i)
      call SaveRmat(nr,message,ier)
      if(ier.ne.0) goto 900
      call str_string(filename,'rmat from #',message)
      ier = 0
  900 continue
      if(ier.ne.0) then
        rmatavailable(nr) = .false.
      else
        rmatavailable(nr) = .true.
      endif
      call CountRmat
      return
  950 continue
      call str_2string(message,filename,'# from #',message)
      return
      end                       ! ReadRmat
      subroutine ReadRmatList(rmatfilename,nr,message,ier)
      character rmatfilename*(*) ! input
      integer   nr              ! input
      character message*(*)     ! output
      integer   ier             ! output
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer activermat
      logical DoRmatTrans
      logical TmatIsRealList(maxnrmat)
      real    reducedrmatlist(3,3,maxnrmat)
      real    rmatlist(3,3,maxnrmat)
      real    dmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,TmatIsRealList,
     +     reducedrmatlist,rmatlist,dmatlist,tmatlist,sigmacelllist,
     +     sigmavolumelist
      character rmatbravaislist(maxnrmat)*2
      character bravaislist(maxnrmat)*2
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer QvecTypes(maxnrmat)
      integer nqveclist(maxnrmat)
      real    qvecradiuslist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      logical nqvpautolist(maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      logical qvpactivelist(maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/QvecTypes,nqveclist,qvecradiuslist,
     +     qvvectorlist,qvorderlist,nqvpautolist,nqvplist,qvplist,
     +     qvpactivelist,qvphkllist
      external  rmatxxx
      integer   unit
      character line*80
      character filename*80
      character filename2*80
      character message2*256
      integer   lf
      filename = rmatfilename
      call open_file(filename,unit,message,ier)
      if(ier.ne.0) then
        call build_file(filename,' ','.rmat',filename2,lf)
        call open_file(filename2,unit,message2,ier)
        if(ier.ne.0) then
          if(filename.ne.filename2) then
            call str_2string(message,filename2,'# or #',message)
          endif
          return
        endif
      endif
      read(unit,100,iostat=ier) line
  100 format(a)
      call ReadRmat(unit,nr,line,message,ier)
      close(unit)
      return
      end                       ! readrmatList
      subroutine RmatInit(br)
      character br*1            ! input
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer i
      call UnitMatrix(tmat)
      TmatIsReal = .false.
      rmatbravais = br
      bravais = br
      do i=1,6
        sigmacell(i) = 0.0
      enddo
      sigmavolume = 0.0
      qvectype = QvecTypeNone
      qvecradius = -1.0
      qvecradiusactive = -1.0
      nqvec = 0
      nqvp = 0
      nqvpauto = .false.
      rmattitle = ' '
      pg = ' '
      QvecTypeNames(QvecTypeNone) = 'NONE'
      QvecTypeNames(QvecTypeModulated) = 'MODULATED'
      QvecTypeNames(QvecTypeCOMPOSITE) = 'COMPOSITE'
      return
      end                       ! RmatInit
      subroutine RmatMessage(nr,ier,message)
      integer   nr
      integer   ier
      character message*(*)
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      if(ier.eq.RmatErrorNone) then
         call str_integer(nr,'Rmat # ok',message)
      else if(ier.eq.RmatErrorRange) then
        call str_2integer(nr,maxnrmat,
     +       'Matrix number (#) out of range (1-#)',message)
      else if(ier.eq.RmatErrorUnavailable) then
         call str_integer(nr,'Rmat # is unavailable',message)
      else
         call str_2integer(nr,ier,'Unknown rmat(#) error (#)',message)
      endif
      return
      end                       ! RmatMessage
      block data rmatxxx
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer activermat
      logical DoRmatTrans
      logical TmatIsRealList(maxnrmat)
      real    reducedrmatlist(3,3,maxnrmat)
      real    rmatlist(3,3,maxnrmat)
      real    dmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,TmatIsRealList,
     +     reducedrmatlist,rmatlist,dmatlist,tmatlist,sigmacelllist,
     +     sigmavolumelist
      character rmatbravaislist(maxnrmat)*2
      character bravaislist(maxnrmat)*2
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer QvecTypes(maxnrmat)
      integer nqveclist(maxnrmat)
      real    qvecradiuslist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      logical nqvpautolist(maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      logical qvpactivelist(maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/QvecTypes,nqveclist,qvecradiuslist,
     +     qvvectorlist,qvorderlist,nqvpautolist,nqvplist,qvplist,
     +     qvpactivelist,qvphkllist
      real an0
      parameter (an0 = 0.0/grad)
      data rmatavailable /maxnrmat*.false./
      data highestnrmat,activermat /0,0/
      data DoRmatTrans /.true./
      data pgAxisZero /0.0/
      data pgAngleZero /an0/
      data qvecradius /-1.0/
      end ! block data rmatxxx
      subroutine SaveRmat(nr,message,ier)
      integer   nr              ! input
      character message*(*)     ! output
      integer   ier             ! output
      real Pi,PiOver2,TwoPi,Grad
      parameter (Pi=3.1415927)
      parameter (TwoPi = 2*Pi)
      parameter (PiOver2 = Pi / 2.0)
      parameter (Grad = 180.0/Pi)
      integer   OutputNone
      integer   OutputNormal
      integer   OutputFull
      integer   OutputDebug
      parameter (OutputNone=0)
      parameter (OutputNormal=1)
      parameter (OutputFull=2)
      parameter (OutputDebug=3)
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer activermat
      logical DoRmatTrans
      logical TmatIsRealList(maxnrmat)
      real    reducedrmatlist(3,3,maxnrmat)
      real    rmatlist(3,3,maxnrmat)
      real    dmatlist(3,3,maxnrmat)
      real    tmatlist(3,3,maxnrmat)
      real    sigmacelllist(6,maxnrmat)
      real    sigmavolumelist(maxnrmat)
      common /common_rmatlist/ activermat,doRmatTrans,TmatIsRealList,
     +     reducedrmatlist,rmatlist,dmatlist,tmatlist,sigmacelllist,
     +     sigmavolumelist
      character rmatbravaislist(maxnrmat)*2
      character bravaislist(maxnrmat)*2
      character pglist(maxnrmat)*6
      character rmattitlelist(maxnrmat)*80
      common /common_rmatlist_char/ rmatbravaislist,bravaislist,
     +     pglist,rmattitlelist
      integer QvecTypes(maxnrmat)
      integer nqveclist(maxnrmat)
      real    qvecradiuslist(maxnrmat)
      real    qvvectorlist(3,maxqvec,maxnrmat)
      integer qvorderlist(maxqvec,maxnrmat)
      logical nqvpautolist(maxnrmat)
      integer nqvplist(maxnrmat)
      integer qvplist(maxqvec,maxqvp,maxnrmat)
      logical qvpactivelist(maxqvp,maxnrmat)
      real    qvphkllist(3,maxqvp,maxnrmat)
      common /common_qveclist/QvecTypes,nqveclist,qvecradiuslist,
     +     qvvectorlist,qvorderlist,nqvpautolist,nqvplist,qvplist,
     +     qvpactivelist,qvphkllist
      external  rmatxxx
      logical  SameVec
      integer i
      integer j
      logical keepsigma
      real    a1(3)
      real    a2(3)
      real    al1(3)
      real    al2(3)
      call CheckRmat(nr,ier)
      if(ier.eq.RmatErrorRange) then
         call RmatMessage(nr,ier,message)
         return
      endif
      call savemat(reducedrmat,reducedrmatlist,nr)
      call savemat(tmat,tmatlist,nr)
      TmatIsRealLIst(nr) = TmatIsReal
      rmatbravaislist(nr) = rmatbravais
      bravaislist(nr) = bravais
      call invertmat(reducedrmat,dmat,ier)
      if(ier.ne.0) then
        message = 'SaveRmat: Cannot invert reduced rmat'
        return
      endif
      if(DoRmatTrans.and.TmatIsReal) then
        call CellDim(dmat,a1,al1)
        call MatMat(tmat,dmat,dmat)
        call CellDim(dmat,a2,al2)
        keepsigma = (SameVec(a1,a2,0.1).and.SameVec(al1,al2,0.1/grad))
        call invertmat(dmat,rmat,ier)
        if(ier.ne.0) then
          message = 'SaveRmat: Cannot invert tmat*dmat'
          return
        endif
      else
        call copymat(reducedrmat,rmat)
        keepsigma = .true.
      endif
      call savemat(rmat,rmatlist,nr)
      call savemat(dmat,dmatlist,nr)
      if(.not.keepsigma) then
        do i=1,6
          sigmacell(i) = 0.0
        enddo
        sigmavolume = 0.0
      endif
      do i=1,6
        sigmacelllist(i,nr) = sigmacell(i)
      enddo
      sigmavolumelist(nr) = sigmavolume
      rmattitlelist(nr) = rmattitle
      QvecTypes(nr) = QvecType
      QvecRadiusList(nr) = QvecRadius
      if(nqvec.gt.0) then
        if (nqvp.eq.0)  then
          call QVbuild(message,ier)
          if(ier.ne.0) return
        endif
        call QVbuildHkl
      endif
      nqveclist(nr) = nqvec
      do i=1,nqvec
        do j=1,3
          qvvectorlist(j,i,nr) = qvvector(j,i)
        enddo
        qvorderlist(i,nr) = qvorder(i)
      enddo
      nqvplist(nr) = nqvp
      nqvpautolist(nr) = nqvpauto
      do i=1,nqvp
        do j=1,nqvec
          qvplist(j,i,nr) = qvp(j,i)
        enddo
        qvpactivelist(i,nr) = qvpactive(i)
        do j=1,3
          qvphkllist(j,i,nr) = qvphkl(j,i)
        enddo
      enddo
      if(pg.eq.' ') then
        call dmatpg(dmat,pgAxisZero,pgAngleZero,pg)
        if(pg.ne.'-1') then
          TmatIsReal = .true.
          TmatIsRealLIst(nr) = TmatIsReal
        endif
      endif
      pglist(nr) = pg
      rmatavailable(nr) = .true.
      ier = 0
      activermat = nr
      call str_integer(nr,'Stored rmat as #',message)
      call CountRmat
      return
      end                       ! SaveRmat
      subroutine SetQvecRadiusActive
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      real    absvec
      integer iqv
      real    v(3)
      real    hkl(3)
      real    av
      real    avmax
      if(qvecradius.gt.0.0) then
        qvecRadiusActive = qvecRadius
      else
        avmax = 0.0
        do iqv=1,nqvec
          call getvec(qvvector,iqv,v)
          call facIvec(qvorder(iqv),v,hkl)
          call MatVec(rmat,hkl,v)
          av = absvec(v)        ! = 2sin(th)/lambda
          avmax=max(avmax,av)
        enddo
        qvecRadiusActive = avmax
      endif
      return
      end                       ! SetQvecRadiusActive
      subroutine SetQvecType(s,message,ier)
      character s*(*)
      character message*(*)
      integer   ier
      integer maxnrmat
      parameter (maxnrmat=15)
      integer maxqvec
      parameter (maxqvec=4)
      integer maxqvp
      parameter (maxqvp=200)
      real    rmat(3,3)
      real    dmat(3,3)
      real    reducedrmat(3,3)
      real    tmat(3,3)
      real    sigmacell(6)
      real    sigmavolume
      integer highestnrmat
      integer nrmatavailable
      integer highestnqvec
      real    pgaxisZero
      real    pganglezero
      logical TmatIsReal
      logical rmatavailable(maxnrmat)
      common /common_rmat/ rmat,dmat,reducedrmat,tmat,sigmacell,
     +     sigmavolume,highestnrmat,nrmatavailable,highestnqvec,
     +     pgAxisZero,pgAngleZero,rmatavailable,TmatIsReal
      character rmatbravais*2
      character bravais*2
      character pg*6
      character rmattitle*80
      common /common_rmat_char/ rmatbravais,bravais,pg,rmattitle
      integer QvecTypeNone
      integer QvecTypeModulated
      integer QvecTypeComposite
      integer MaxQvecType
      parameter (QvecTypeNone=1)
      parameter (QvecTypeModulated=QvecTypeNone+1)
      parameter (QvecTypeComposite=QvecTypeModulated+1)
      parameter (MaxQvecType=QvecTypeComposite)
      integer QvecType
      real    qvecradiusactive
      real    qvecradius
      integer nqvec
      real    qvvector(3,maxqvec)
      integer qvorder(maxqvec)
      logical nqvpauto
      integer nqvp
      integer qvp(maxqvec,maxqvp)
      logical qvpactive(maxqvp)
      real    qvphkl(3,maxqvp)
      common /common_qvec/ QvecType,qvecradiusactive,qvecradius,nqvec,
     +     qvvector,qvorder,nqvpauto,nqvp,qvp,qvpactive,qvphkl
      character QvecTypeNames(MaxQvecType)*10
      common /common_qvec_char/ QvecTypeNames
      integer RmatErrorNone
      integer RmatErrorRange
      integer RmatErrorUnavailable
      parameter (RmatErrorNone=0)
      parameter (RmatErrorRange=RmatErrorNone+1)
      parameter (RmatErrorUnavailable=RmatErrorRange+1)
      integer   i
      character us*80
      call upcase(s,us)
      do i=1,MaxQvecType
        if(us.eq.QvecTypeNames(i)) then
          QvecType = i
          call str_string(QvecTypeNames(QvecType),'QvecType set to #',
     +         message)
          ier = 0
          return
        endif
      enddo
      ier = 1
      call str_string(us,'Unknown QvecType:#',message)
      QvecType = QvecTypeNone
      return
      end                       ! SetQvecType
      subroutine sigmastring(sigcell,sigvol,title,s,ns)
      real      sigcell(6)
      real      sigvol
      character title*(*)
      character s*(*)
      integer   ns
      integer   length
      integer   str_compress
      integer   lt
      lt = length(title)
      if(lt.eq.0) then
        write(s,100) 'Sigma',sigcell,sigvol
  100   format(a,1x,3f9.4,3f9.3,' Volume',f12.2)
      else
        write(s,100) title(1:lt),sigcell,sigvol
      endif
      ns = str_compress(s,s)
      return
      end                       ! sigmastring
      subroutine WriteCell(unit,dmat,pg,s)
      implicit none
      integer   unit            ! input
      real      dmat(3,3)       ! input
      character pg*(*)          ! input
      character s*(*)           ! input
      integer   length
      real      MatVol
      character line*80
      integer   ls
      real      a(3)
      real      al(3)
      logical   changed
      real      v
      real      dm(3,3)
      real      rm(3,3)
      character message*256
      integer   ier
      call celldim(dmat,a,al)
      call CellConstraints(pg,a,al,changed)
      if(changed) then
        call BuildRmatFromCell(a,al,rm,dm,message,ier)
        v = matvol(dm)
      else
        v = matvol(dmat)
      endif
      call gradvec(al,al)
      write (line,100) a,al,v
  100 format(3f10.5,3f9.4,' V=',f12.2)
      ls = length(s)
      if(ls.ne.0) then
        call str_2string_write(unit,s,line,'#: #')
      else
        call str_string_write(unit,line,'Cell: #')
      endif
      return
      end                       ! WriteCell
